import React from "react";
import { Progress } from "antd";
import "./progress.less";

class MyProgress extends React.Component {
  constructor(props) {
    super(props);
    this.state = {
      percent: 0
    };

    this.timer = null;
  }

  componentDidMount() {
    const { allTime } = this.props;
    if (!allTime) return;
    this.setIntervalFn(allTime);
  }
  componentWillReceiveProps(nextprops) {
    const { isrefresh, status, allTime } = nextprops;
    if (!allTime) return;
    if( status === 'exception'){
      window.clearInterval(this.timer);
    }
    if(isrefresh){
      this.setState({
        percent: 0
      },()=>{
        this.setIntervalFn(allTime);
      });
   
    }
  }

  componentWillUnmount() {
    window.clearInterval(this.timer);
  }

  setIntervalFn = (allTime) =>{
    const time = allTime / 100;
    this.timer = setInterval(() => {
      if (this.state.percent >= 99) {
        window.clearInterval(this.timer);
      } else {
        this.setState({
          percent: this.state.percent + 1
        });
      }
    }, time);
  }

  render() {
    const { percent } = this.state;
    const { status, type, width, title, } = this.props;
    return (
      <div
        className="com-progress-container"
        style={{ width: width || "360px" }}
      >
        <div className="com-progress-content">
          <p className="waiting">{title}</p>
          <Progress percent={percent} status={status} type={type} />
        </div>
      </div>
    );
  }
}

export default MyProgress;
